zoukankan      html  css  js  c++  java
  • CodeForces

    Little Nastya has a hobby, she likes to remove some letters from word, to obtain another word. But it turns out to be pretty hard for her, because she is too young. Therefore, her brother Sergey always helps her.

    Sergey gives Nastya the word t and wants to get the word p out of it. Nastya removes letters in a certain order (one after another, in this order strictly), which is specified by permutation of letters' indices of the word ta1... a|t|. We denote the length of word x as |x|. Note that after removing one letter, the indices of other letters don't change. For example, if t = "nastya" and a = [4, 1, 5, 3, 2, 6] then removals make the following sequence of words "nastya"  "nastya"  "nastya" "nastya"  "nastya"  "nastya"  "nastya".

    Sergey knows this permutation. His goal is to stop his sister at some point and continue removing by himself to get the word p. Since Nastya likes this activity, Sergey wants to stop her as late as possible. Your task is to determine, how many letters Nastya can remove before she will be stopped by Sergey.

    It is guaranteed that the word p can be obtained by removing the letters from word t.

    Input

    The first and second lines of the input contain the words t and p, respectively. Words are composed of lowercase letters of the Latin alphabet (1 ≤ |p| < |t| ≤ 200 000). It is guaranteed that the word p can be obtained by removing the letters from word t.

    Next line contains a permutation a1, a2, ..., a|t| of letter indices that specifies the order in which Nastya removes letters of t (1 ≤ ai ≤ |t|, all ai are distinct).

    Output

    Print a single integer number, the maximum number of letters that Nastya can remove.

    Examples

    Input
    ababcba
    abb
    5 3 4 1 7 6 2
    Output
    3
    Input
    bbbabb
    bb
    1 6 3 4 2 5
    Output
    4

    Note

    In the first sample test sequence of removing made by Nastya looks like this:

    "ababcba"  "ababcba"  "ababcba"  "ababcba"

    Nastya can not continue, because it is impossible to get word "abb" from word "ababcba".

    So, Nastya will remove only three letters. 

    题意:当初看这个题看了快一小时了还是不理解,我。。。。

    就是给了两个序列,序列a肯定包含序列b,然后给了一个删除序列,删除给定位置的字符,然后依照顺序删,看最多能删几个

    思路:一开始肯定想的是直接遍历,然后用个标记数组直接记录哪个被删了,然后就T了

    范围是 (1 ≤ |p| < |t| ≤ 200 000).然后我们想下,我们就是想求一个看能最多删几个的东西,去遍历可以得到,但是一般遍历能得到的东西,我们就可以想到二分,

    如果删这么多满足的话,就继续往后二分,如果不行往前二分,时间复杂度就可以满足了

    #include <cstdio>
    #include <cstring>
    #include <algorithm>
    #include <cmath>
    #include <iostream>
    #include <vector>
    #include <queue>
    #include <string>
    #include <set>
    #include <map>
    using namespace std;
    const int maxn = 1e6+100;
    char a[maxn];
    char b[maxn];
    char tmp[maxn];
    int c[maxn],n;
    bool slove(int pos)
    {
        strcpy(tmp,a);
        for(int i=0;i<pos;i++)
            tmp[c[i]-1] = 0;
        int res = 0;
        for(int i=0;i<n;i++)
        {
            if(tmp[i]==b[res])
                res++;
            if(res==strlen(b))
                return true;
        }
        if(res==strlen(b))
            return true;
        else
            return false;
    }
    int main()
    {
        scanf("%s %s",a,b);
        n = strlen(a);
        for(int i=0;i<n;i++)
            scanf("%d",&c[i]);
        int l = 0,r = n;
        int k = 100;
        while(k--)
        {
            int mid = (l+r)/2;
            if(slove(mid))
                l = mid;
            else
                r = mid;
        }
        printf("%d
    ",l);
        return 0;
    }

    要熟练掌握二分思想和满足二分的情况

    刷多点题提高敏感度

  • 相关阅读:
    Collectors.reducing总结
    Ubuntu 换源看这一篇就够了
    基于Vue2和Node.js的反欺诈系统设计与实现
    Flink源码解析(四)——从Flink集群部署和任务提交模式看Flink任务的核心组件
    SaaS架构(二) 多租户数据隔离方案
    网络IO模型(BIO,NIO,AIO)
    Gale-Shapley算法
    Java 内存模型
    上位机那些事儿
    三菱PLC之SLMP协议报文说明
  • 原文地址:https://www.cnblogs.com/Lis-/p/9240929.html
Copyright © 2011-2022 走看看